<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/renormvec.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>renormvec.c</h1><a href="renormvec_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: renormvec.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="util_8h.html#abba3d002260d6e3e062ac69a80300aa4">00029</a> PetscReal <a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(Vec v, PetscReal normset, PetscReal normtol, <span class="keywordtype">int</span> dim)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   <span class="keywordtype">int</span> t_vlen;
<a name="l00034"></a>00034   ierr = VecGetLocalSize(v,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;t_vlen);CHKERRQ(ierr);
<a name="l00035"></a>00035   assert(t_vlen%dim==0);
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   PetscReal *ta_v;
<a name="l00038"></a>00038   ierr = VecGetArray(v,&amp;ta_v);CHKERRQ(ierr);
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   assert(dim==<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>); <span class="comment">/* otherwise replace my_* calls by cblas calls again */</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   PetscReal normmax,normmin;
<a name="l00043"></a>00043   normmax=0;
<a name="l00044"></a>00044   normmin=PETSC_MAX;
<a name="l00045"></a>00045   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;t_vlen/dim;i++) {
<a name="l00046"></a>00046     PetscReal nrm;
<a name="l00047"></a>00047     nrm=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(dim,ta_v+dim*i,1);
<a name="l00048"></a>00048     normmax=PetscMax(normmax,nrm);
<a name="l00049"></a>00049     normmin=PetscMin(normmin,nrm);
<a name="l00050"></a>00050   }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   PetscReal gnormmax,gnormmin;
<a name="l00053"></a>00053   ierr = PetscGlobalMax(&amp;normmax,&amp;gnormmax,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00054"></a>00054   ierr = PetscGlobalMin(&amp;normmin,&amp;gnormmin,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   PetscReal normdev;
<a name="l00057"></a>00057   normdev = PetscMax(PetscAbsReal(gnormmax-normset),
<a name="l00058"></a>00058                      PetscAbsReal(gnormmin-normset));
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="comment">/* rescale vectors only if maximum deviation is larger than tolerance */</span>
<a name="l00061"></a>00061   <span class="keywordflow">if</span> (PetscAbsReal(normdev) &gt; normtol) {
<a name="l00062"></a>00062     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;t_vlen/dim;i++) {
<a name="l00063"></a>00063       <span class="comment">/* recalculate norm since we did not store it anywhere */</span>
<a name="l00064"></a>00064       PetscReal nrm;
<a name="l00065"></a>00065       nrm=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(dim,ta_v+dim*i,1);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067       <span class="comment">/* work around problems if nrm is small */</span>
<a name="l00068"></a>00068       <span class="keywordflow">if</span> (nrm&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00069"></a>00069         <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(dim,normset/nrm,ta_v+dim*i,1);
<a name="l00070"></a>00070       }
<a name="l00071"></a>00071       <span class="comment">/* if nrm is too small and normtol==0</span>
<a name="l00072"></a>00072 <span class="comment">         set vector (at will) parallel to z-axis</span>
<a name="l00073"></a>00073 <span class="comment">         TODO: good idea? problem for GMR calculation</span>
<a name="l00074"></a>00074 <span class="comment">      */</span>
<a name="l00075"></a>00075       <span class="comment">/*</span>
<a name="l00076"></a>00076 <span class="comment">      else if (normtol==0){</span>
<a name="l00077"></a>00077 <span class="comment">      */</span>
<a name="l00078"></a>00078       <span class="keywordflow">else</span> {
<a name="l00079"></a>00079         ta_v[dim*i+0]=0.0;
<a name="l00080"></a>00080         ta_v[dim*i+1]=0.0;
<a name="l00081"></a>00081         ta_v[dim*i+2]=1.0;
<a name="l00082"></a>00082       }
<a name="l00083"></a>00083     }
<a name="l00084"></a>00084   }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   VecRestoreArray(v,&amp;ta_v);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(normdev);
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

